/*
 * Exorciser - www.educeth.ch/exorciser � Copyright 2000-2004 Swiss Federal
 * Institue of Technology, Z�rich Switzerland
 */
package ch.ethz.exorciser;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.ScrollPaneConstants;

/**
 * @author Vincent Tscherter
 */
public class ExerciseUIFactory {

	public static final void createExerciseUI(JComponent main, JComponent ctrl,
			JComponent msg, JComponent target) {
		target.removeAll();
		target.setLayout(new BorderLayout(5, 5));
		JPanel r = new JPanel(new BorderLayout(5, 5));
		r.add(ctrl, BorderLayout.NORTH);
		JScrollPane sp = new JScrollPane(msg,
				ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		r.add(sp, BorderLayout.CENTER);
		target.setBackground(r.getBackground());
		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
		split.setResizeWeight(.8);
		split.add(main);
		split.add(r);
		target.add(split, BorderLayout.CENTER);
		target.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		ctrl.setBorder(BorderFactory.createCompoundBorder(BorderFactory
				.createLoweredBevelBorder(), BorderFactory.createEmptyBorder(
				10, 10, 10, 10)));
		main.setBorder(BorderFactory.createCompoundBorder(BorderFactory
				.createLoweredBevelBorder(), BorderFactory.createEmptyBorder(5,
				5, 5, 5)));
		sp.setBorder(BorderFactory.createCompoundBorder(BorderFactory
				.createLoweredBevelBorder(), BorderFactory.createEmptyBorder(0,
				0, 0, 0)));
		sp.getViewport().setBackground(Color.white);
	}

	public static JEditorPane createTaskPane(Exercise e) {
		JEditorPane ep = new JEditorPane("text/html", //$NON-NLS-1$
				Messages.getString("Exercise.template").replaceAll("\\$TITLE", //$NON-NLS-1$ //$NON-NLS-2$
						e.getTitle()).replaceAll("\\$EXERCISE", e.getTask())); //$NON-NLS-1$
		ep.setEditable(false);
		return ep;
	}

	public static void resetTaskText(JEditorPane ep, Exercise e) {
		ep.setText(Messages.getString("Exercise.template").replaceAll( //$NON-NLS-1$
				"\\$TITLE", e.getTitle()) //$NON-NLS-1$
				.replaceAll("\\$EXERCISE", e.getTask())); //$NON-NLS-1$
	}
}