/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser;

import java.awt.Cursor;
import java.util.regex.Pattern;

import javax.swing.JComponent;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

/**
 * @author Vincent Tscherter
 */
public class ExtendedHyperlinkListener implements HyperlinkListener {

   private static Object loadPage (String request) {
      String[] r = Pattern.compile("\\?").split(request); //$NON-NLS-1$
      try {
         if (r.length == 1) {
            return Class.forName(r[0]).newInstance();
         } else if (r.length == 2) {
            Class[] c = { String.class};
            Object[] q = { r[1]};
            return Class.forName(r[0]).getConstructor(c).newInstance(q);
         }
         return null;
      } catch (Exception e) {
         // Debug.showException(e);
      }
      return null;
   }

   public void hyperlinkUpdate (HyperlinkEvent event) {
      ((JComponent) event.getSource()).setCursor(Cursor
            .getPredefinedCursor(Cursor.WAIT_CURSOR));
      if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
         Object page = loadPage(event.getDescription());
         if (page != null && page instanceof Page) {
            Browser.getBrowser((JComponent) event.getSource()).setPage(
                  ((Page) page));
            Browser.statusOut(page, event.getDescription()
                  + Messages.getString("Browser.message.page_loaded")); //$NON-NLS-1$
         } else { // try to invoce a method
            Page p = Browser.getBrowser((JComponent) event.getSource())
                  .getPage();
            try {
               String[] r = Pattern.compile("\\?") //$NON-NLS-1$
                     .split(event.getDescription());
               if (r.length == 1) {
                  p.getClass().getMethod(r[0], new Class[0]).invoke(p,
                        new Object[0]);
               } else if (r.length == 2) {
                  Class[] c = { String.class};
                  Object[] q = { r[1]};
                  p.getClass().getMethod(r[0], c).invoke(p, q);
               }
               Browser.statusOut(event.getSource(), event.getDescription()
                     + Messages.getString("Browser.message.command_executed")); //$NON-NLS-1$
            } catch (Exception e) {
               // ev a url
               if (ClassLoader.getSystemResource(event.getDescription()) != null) {
                  Browser.getBrowser((JComponent) event.getSource()).setPage(
                        new HTML(event.getDescription()));
               } else {
               	Debug.showException(e);
//                  Debug.showException(new Exception("invalid hyperlink: " //$NON-NLS-1$
//                        + event.getDescription())); 
               }
            }
         }
      } else if (event.getEventType() == HyperlinkEvent.EventType.ENTERED) {
         Browser.statusOut(event.getSource(), event.getDescription());
      } else {
         Browser.statusOut(event.getSource(), " "); //$NON-NLS-1$
      }
      ((JComponent) event.getSource()).setCursor(Cursor
            .getPredefinedCursor(Cursor.HAND_CURSOR));
   }
}