/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * @author Vincent Tscherter
 */
public class HTML extends JPanel implements Page {

   private JEditorPane ep = new JEditorPane();

   public HTML (String indexfile) {
      super(new BorderLayout());
      add(new JScrollPane(ep), BorderLayout.CENTER);
      ep.setEditable(false);
      ep.addHyperlinkListener(new ExtendedHyperlinkListener());
      try {
         ep.setPage(ClassLoader.getSystemResource(indexfile));
      } catch (Exception ex) {
         ex.printStackTrace(System.err);
      }
   }

   public HTML () {
      super(new BorderLayout());
      add(new JScrollPane(ep), BorderLayout.CENTER);
      ep.setEditable(false);
      ep.addHyperlinkListener(new ExtendedHyperlinkListener());
   }

   public void showFile (String file) {
      try {
         ep.setPage(ClassLoader.getSystemResource(file));
      } catch (Exception ex) {
         ex.printStackTrace(System.err);
      }
   }

   public String getTitle () {
      String s = ep.getText();
      int left = s.indexOf("<title>"); //$NON-NLS-1$
      int right = s.indexOf("</title>"); //$NON-NLS-1$
      if (left != -1 && right != -1) { return s.substring(left
            + "<title>".length(), right); //$NON-NLS-1$
      }
      return null;
   }

   public JComponent getPageUI () {
      return this;
   }
}