/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser;

import javax.swing.ImageIcon;

/**
 * @author Vincent Tscherter
 */
public class Shared {

    public static final String UNDO = Messages.getString("Shared.undo"); //$NON-NLS-1$

    public static final String REDO = Messages.getString("Shared.redo"); //$NON-NLS-1$

    public static final String COPY = Messages.getString("Shared.copy"); //$NON-NLS-1$
    
    public static final String PASTE = Messages.getString("Shared.paste"); //$NON-NLS-1$

    public static final String START = Messages.getString("Shared.start"); //$NON-NLS-1$

    public static final String STOP = Messages.getString("Shared.stop"); //$NON-NLS-1$

    public static final String HOME = Messages.getString("Shared.home"); //$NON-NLS-1$

    public static final String BACK = Messages.getString("Shared.back"); //$NON-NLS-1$

    public static final String FORWARD = Messages.getString("Shared.forward"); //$NON-NLS-1$

    public static final String CANCEL = Messages.getString("Shared.cancel"); //$NON-NLS-1$

    public static final String DONE = Messages.getString("Shared.done"); //$NON-NLS-1$

    public static final String DELETE = Messages.getString("Shared.delete"); //$NON-NLS-1$

    public static final String CORRECT = Messages.getString("Shared.correct"); //$NON-NLS-1$

    public static final String ERROR = Messages.getString("Shared.error"); //$NON-NLS-1$

    public static final String EXPORT = Messages.getString("Shared.export"); //$NON-NLS-1$

    public static final String OKAY = Messages.getString("Shared.ok"); //$NON-NLS-1$

    public static final String OPEN = Messages.getString("Shared.open"); //$NON-NLS-1$

    public static final String PAUSE = Messages.getString("Shared.pause"); //$NON-NLS-1$

    public static final String RUN_BACKWARD = Messages
            .getString("Shared.run_backward"); //$NON-NLS-1$

    public static final String RUN_FORWARD = Messages
            .getString("Shared.run_forward"); //$NON-NLS-1$

    public static final String SAVE = Messages.getString("Shared.save"); //$NON-NLS-1$

    public static final String SAVE_AS = Messages.getString("Shared.save_as"); //$NON-NLS-1$

    public static final String STEP_BACK = Messages
            .getString("Shared.setp_backward"); //$NON-NLS-1$

    public static final String STEP_FORWARD = Messages
            .getString("Shared.step_forward"); //$NON-NLS-1$

    public static final String STOP_AND_RESET = Messages
            .getString("Shared.stop_and_reset"); //$NON-NLS-1$
    
    public static ImageIcon loadIcon(String file) {
        return new ImageIcon(ClassLoader.getSystemResource(file));
     }
}