/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.fsmgui;

import javax.swing.event.MouseInputListener;


public interface FSMControllerInterface {

	public MouseInputListener getMouseInputListener();

	public FSMEditorOperations getFSMEditorOperations();

	public FSMView getView();

	public FSMModelInterface getModel();

	/** Use to clear, change name, change alphabet, add trapstate etc. */
	public void changeFSM(int x, int y);

	public FSMStateInterface addState(double x, double y);

	public boolean addTransitionAllowed(FSMStateInterface state);

	public void addTransition(Transition transition, int x, int y);

	/** use to setAccepting, setStart, setLabel */
	public void changeState(FSMStateInterface state, int x, int y);

	public void selectState(State state);

	/** use to set Label */
	public void changeTransition(Transition transition, int x, int y);

	/** use to move transition */
	public void changeTransition(Transition transition, State sOld, State sNew);

	public void selectTransition(Transition transition);

}