/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.fsmgui;

import java.util.Set;



/**
 * @author		Reto Lamprecht
 */
public interface FSMModelInterface {

	public void addFSMModelListener(FSMModelListener listener);

	public void removeFSMModelListener(FSMModelListener listener);

	public void notifyFSMModelListeners(FSMEvent event);

	public void setAlphabet(Alphabet alphabet);

	public Alphabet getAlphabet();

	public void addState(FSMStateInterface state);

	public void removeState(FSMStateInterface state);

	public Set getAllStates();

	public void clear();

	public void setStartState(FSMStateInterface state);

	public FSMStateInterface getStartState();

	public void setName(String name);

	public String getName();
	
	public Set getStatesAfter(String inputString);

	public void copy(); 
	public void paste();
	public boolean isPasteable();
}