/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.fsmgui;

import java.util.Set;

/**
 * @author		Reto Lamprecht
 */
public interface FSMStateInterface {

	public void addTransition(Object input, FSMStateInterface target);

	public void removeTransition(Object input, FSMStateInterface target);

	/** Returns all input-object that are associated with the transitions emanating from this state.
	*/
	public Set getInputs();

	public Set getNextStateSet(Object input);

	public void setPosition(double x, double y);

	public double getX();

	public double getY();

	public void setLabel(Object label);

	public Object getLabel();

	public void setAccepting(boolean b);

	public boolean isAccepting();

	public boolean isStartState();

}