/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.fsmgui;


/** Interface to accept state and transition selections from FAscape.
 *  Till now, FAscape has exactly one FAscapeListener
 */
public interface FSMViewListener {
	/** called from FAscape.selectState.
	 *  must handle null-States
	 */
	public void stateSelected(State fas);

	public void stateHighlighted(State fas);

	public void stateMarked(State fas);

	/** called from FAscape.selectTransition.
	 *  must handle null-Transitions
	 */
	public void transitionSelected(Transition fat);

	public void transitionHighlighted(Transition fat);

	public void transitionMarked(Transition fat);

}