/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import ch.ethz.exorciser.Messages;
import ch.ethz.exorciser.Shared;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public class AcceptSign extends JPanel {

    public static final ImageIcon accept = Shared.loadIcon(Messages
            .getString("FSM.icon.accept")); //$NON-NLS-1$

    public static final ImageIcon reject = Shared.loadIcon(Messages
            .getString("FSM.icon.reject")); //$NON-NLS-1$

    ImageIcon state;

    public AcceptSign() {
        state = reject;
    }

    public void setAccept(boolean b) {
        if (b)
            state = accept;
        else
            state = reject;
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(state.getImage(), 0, 0, 18, 20, this);
    }

    public Dimension getPreferredSize() {
        return new Dimension(20, 20);
    }
}