/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.util.Collection;
import java.util.Set;

import ch.ethz.exorciser.fsmgui.FSMModelInterface;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public interface BasicFA extends FSMModelInterface {	public static final int LAYOUT_CIRCLE = 1;

	public static final int LAYOUT_DIAGONAL = 2;
	public static final int LAYOUT_ORGANIC = 3;

	public static final Boolean NON_ACCEPTING = Boolean.FALSE;
 
	public static final int USER_DEFINED = 0;

	public void addState(State state);
	public void clear();
	public Object clone();
	public boolean containsTransitionOnInput(Character c);
	public void deleteAllTransitions();
	public void deleteState(State state) throws FAException;
	public Set getAcceptingStates();
	public int getLayoutType();
	public String getName();
	public Set getNotReachableStates() throws FAException;
	public State getRandomState() throws FAException;
	public Set getReachableStates() throws FAException;
	public Set getReachableStates(State state) throws FAException;
	public State getState(String label);
	public Set getStateSet();
	public Set getTrapStates();
	public boolean hasEpsilonTransition();
	public boolean hasMultipleTransitions();
	public boolean hasNoOtherTransitions(Collection inputs);
	public boolean hasTransition(State from, State to, Character inp);
	public boolean hasWayToAcceptingState(State state) throws FAException;
	public boolean isAccepting(State state) throws FAException ;
	public boolean isDeterministic() throws FAException;
	public boolean isLanguageEmpty();
	public boolean isOneOfTheseAccepting(Set states) throws FAException;
	public void reLabelAllStates(String prefix);
	public void setAccepting(State state, boolean flag);
	public void setFA(BasicFA other);
	public void setLayoutType(int type);
	public void setName(String name);
	public void setStartState(State state);
	public int nOfStates();
	
}