/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBoxMenuItem;

import ch.ethz.exorciser.fsmgui.Alphabet;

class CustomAlphHandler implements ActionListener {

	IFAFSMController controller;

	public CustomAlphHandler(IFAFSMController controller) {
		this.controller = controller;
	}

	public void actionPerformed(ActionEvent e) {
		Alphabet a = controller.getModel().getAlphabet();
		String item = e.getActionCommand();

		if (Alphabet.EPSILON.toString().equals(item)) {
			if (a.containsEpsilon()) {
				a.remove(Alphabet.EPSILON);
			} else {
				a.add(Alphabet.EPSILON);
			}
		} else {
			for (int i = 0; i < AlphabetMenu.LETTERS_ALL.size(); i++) {
				if (AlphabetMenu.LETTERS_ALL.get(i).toString().equals(item)) {
					if (((JCheckBoxMenuItem) e.getSource()).getState()) {
						a.add(AlphabetMenu.LETTERS_ALL.get(i));
					} else {
						a.remove(AlphabetMenu.LETTERS_ALL.get(i));
					}
					break;
				}
			}
			for (int i = 0; i < AlphabetMenu.NUMBERS.size(); i++) {
				if (AlphabetMenu.NUMBERS.get(i).toString().equals(item)) {
					if (((JCheckBoxMenuItem) e.getSource()).getState()) {
						a.add(AlphabetMenu.NUMBERS.get(i));
					} else {
						a.remove(AlphabetMenu.NUMBERS.get(i));
					}
					break;
				}
			}
			for (int i = 0; i < AlphabetMenu.SPECIAL.size(); i++) {
				if (AlphabetMenu.SPECIAL.get(i).toString().equals(item)) {
					if (((JCheckBoxMenuItem) e.getSource()).getState()) {
						a.add(AlphabetMenu.SPECIAL.get(i));
					} else {
						a.remove(AlphabetMenu.SPECIAL.get(i));
					}
					break;
				}
			}
		}
	}
}

