/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;


/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public interface FA extends BasicFA {

	public static final String NOT_A_FA = "NOT_A_FA"; //$NON-NLS-1$
	public static final String GFA = "GFA"; //$NON-NLS-1$
	public static final String NFA = "NFA"; //$NON-NLS-1$
	public static final String UFA = "UFA"; //$NON-NLS-1$
	public static final String DFA = "DFA"; //$NON-NLS-1$
	public static final String MFA = "MFA"; //$NON-NLS-1$

	public String getFAType();

	public void complete() throws FAException;
	public void mergeTrapStates() throws FAException;
	public void removeTrapStates() throws FAException;
	public void removeNotReachableStates() throws FAException;

	public void detComplement() throws FAException;
	public void detMinimize() throws FAException;
	public void makeDetOpt() throws FAException;
	public void removeEpsilon() throws FAException;

	public void nDetConcatenation(FA otherFA) throws FAException;
	public void detUnion(FA otherFA) throws FAException;
	public void nDetUnion(FA otherFA) throws FAException;
	public void detIntersection(FA otherFA) throws FAException;
	public void nDetStar() throws FAException;
	
	public void detMinus(FA otherFA) throws FAException;

	public boolean isEquivalent(FA otherFA) throws FAException;
	public String findWitnessForNonEquivalence(FA other);
	public StatePairs getEquivalencePairs() throws FAException;

	public boolean isLanguageFinite() throws FAException;
	public boolean isLanguageAll() throws FAException;
	
}