/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.Color;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 * 
 * $Log: FAColors.java,v $
 * Revision 1.7  2004/09/09 17:16:46  root
 * useless code removed
 *
 * Revision 1.6  2004/09/09 17:16:18  root
 * log tag added
 *
 */
public class FAColors {

    public static Color STATE = new Color(160, 160, 160);

    public static Color SELECTED_STATE = new Color(100, 130, 230);

    public static Color START_STATE = new Color(160, 160, 120);

    public static Color STATE_LABEL = new Color(20, 50, 20);

    public static Color ACTIVE_STATE = new Color(230, 120, 120);

    public static Color ACTIVE_STATE_ACCEPTING = new Color(210, 30, 30);

    public static Color MARK_MARKED = new Color(240, 140, 140);

    public static Color MARK_MARKED_SELECTED = new Color(200, 50, 80);

    public static Color STARTSTATE_NICK = Color.red.darker();

    public static Color TRANSITION = Color.gray;

    public static Color SELECTED_TRANSITION = new Color(130, 180, 100);

    public static Color TRANSITIONLABEL = brighter(TRANSITION, 50);

    public static Color TRANSITIONLABEL_TEXT = new Color(50, 60, 120);

    public static Color SELECTED_TRANSITIONLABEL = brighter(
            SELECTED_TRANSITION, 50);

    public static Color FASCAPE_BGR = new Color(245, 245, 245);

    public static Color FANAME = new Color(10, 10, 10);

    /** Determins impact of darker(Color) and lighter(Color) */
    public static int LIGHTING = 60;

 
    public static Color brighter(Color color, int light) {
        int r = color.getRed();
        int g = color.getGreen();
        int b = color.getBlue();
        return new Color(Math.min(r + light, 255), Math.min(g + light, 255),
                Math.min(b + light, 255));
    }

}