/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.Frame;

import javax.swing.JComponent;

import ch.ethz.exorciser.fsmgui.Alphabet;
import ch.ethz.exorciser.fsmgui.FSMControllerInterface;
import ch.ethz.exorciser.fsmgui.FSMModelInterface;
import ch.ethz.exorciser.fsmgui.FSMView;
import ch.ethz.exorciser.fsmgui.MVCFactory;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public class IFAMVCFactory implements MVCFactory {

	protected FSMModelInterface model;
	protected FSMView fascape;
	protected FSMControllerInterface controller;

	public IFAMVCFactory(Frame parent) {
		model = new FAModel(""); //$NON-NLS-1$
		model.setAlphabet(Alphabet.create01eAlphabet());
		fascape = new FSMView(model);
		controller = new IFAFSMController(model, fascape, parent);
	}

	public IFAMVCFactory() {
		this(null);
	}

	public FSMModelInterface getModel() {
		return model;
	}

	public void setModel(FSMModelInterface model) {
		this.model = model;
		fascape.setModel(model);
		((IFAFSMController) getController()).setModel(model);
	}

	public JComponent getView() {
		return fascape;
	}

	public FSMControllerInterface getController() {
		return controller;
	}

}