/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;


/**
 * @author Alexander Imfeld
 * @author Reto Lamprecht
 * @author Vincent Tscherter
 */
public class Transition {

	private State fromState_;
	private State toState_;
	private Character input_;

	/**
	 * Create a transition.
	 * 
	 * @param fromState
	 *            State the transition comes from.
	 * @param toState
	 *            State the transition leads to.
	 * @param input
	 *            Input that causes taking the transition.
	 */
	public Transition(State fromState, State toState, Character input) {
		fromState_ = fromState;
		toState_ = toState;
		input_ = input;
	}

	/**
	 * Getter for fromState.
	 */
	public State getFromState() {
		return fromState_;
	}

	/**
	 * Getter for toState.
	 */
	public State getToState() {
		return toState_;
	}

	/**
	 * Getter for input.
	 */
	public Character getInput() {
		return input_;
	}

}