/*
 * Exorciser - www.educeth.ch/exorciser  Copyright 2000-2004 Swiss Federal
 * Institue of Technology, Zrich Switzerland
 */
package ch.ethz.exorciser.ifa;

import java.awt.Frame;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JPopupMenu;

import ch.ethz.exorciser.Messages;

/**
 * Class to build the default context menu and to handle the selections.
 *
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public class ViewerDefaultPopup extends IFADefaultPopup {

	public ViewerDefaultPopup(IFACompleteEditor ifaCmplEd, Frame parent) {
		super(ifaCmplEd, parent);
	}

	public JPopupMenu getPopup(int x, int y) {

		JPopupMenu _menu = new JPopupMenu();
		//	JMenuItem mi;
		JCheckBoxMenuItem cmi;
		//	JRadioButtonMenuItem rmi;

		_menu.add(ViewMenu.getMenu(ifaCmplEd));

		_menu.add(getLayoutMenu());

		_menu.add(getStyleMenu());

		cmi = new JCheckBoxMenuItem(Messages.getString("FSM.popup.track_input")); //$NON-NLS-1$
		_menu.add(cmi);
		cmi.addActionListener(this);
		if (ifaCmplEd.isInputTrackerShowing()) {
			cmi.setState(true);
		}

		_menu.addSeparator();
		_menu.add(copyItem);
		return _menu;
	}

}