/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.Frame;

import ch.ethz.exorciser.fsmgui.FSMEditorOperations;
import ch.ethz.exorciser.fsmgui.FSMModelInterface;
import ch.ethz.exorciser.fsmgui.FSMView;
import ch.ethz.exorciser.fsmgui.StatePopup;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public class ViewerFSMController extends IFAFSMController {

	public ViewerFSMController(
		FSMModelInterface model,
		FSMView fsmView,
		Frame parent) {

		this.model = model;
		this.fsmView = fsmView;
		this.editorOps = new FSMEditorOperations(model, fsmView);

		mouseListener = new ViewerDiagramMouseListener(this);

		fsmView.addMouseListener(mouseListener);
		fsmView.addMouseMotionListener(mouseListener);

		statePopup = new StatePopup(this, parent);
		// lazy binTransPopup = new BinaryCharTransitionPopup(this);
		// lazy transPopup = new CustomTransitionPopup(this);

//		customAlphabet = new Alphabet(Alphabet.EPSILON);
	}

	protected void createDefaultPopup(IFACompleteEditor ifaCmplEd, Frame parent) {
		defaultPopup = new ViewerDefaultPopup(ifaCmplEd, parent);
	}
}