/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.ifa;

import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;

/**
 * @author Reto Lamprecht
 * @author Christian Hfeli
 * @author Vincent Tscherter
 */
public class ViewerMatrixPanel extends MatrixPanel {

	public ViewerMatrixPanel(IFACompleteEditor ifaCmplEd) {
		super(ifaCmplEd);
		this.defaultMatrixPopup = new ViewerMatrixPopup(ifaCmplEd);
	}

	public void mousePressed(MouseEvent e) {
		int modif = e.getModifiers();

		// handle right mouseclicks resp. Ctrl-clicks
		if ((modif & InputEvent.BUTTON3_MASK) > 0
			|| (((modif & InputEvent.BUTTON1_MASK) > 0)
				& ((modif & InputEvent.CTRL_MASK) > 0))) {
			defaultMatrixPopup.getPopup().show(this, e.getX(), e.getY());
		}
		// handle middle mouseclicks resp. Shift-clicks
		else if (
			(modif & InputEvent.BUTTON2_MASK) > 0
				|| (((modif & InputEvent.BUTTON1_MASK) > 0)
					& ((modif & InputEvent.SHIFT_MASK) > 0))) {
			if (e.getClickCount() > 1) {
				zdPane.scale = 1.0;
				zdPane.dx = 0.0;
				zdPane.dy = 0.0;
			} else {
				zoomRef = e.getY();
				zdPane.setScaleRef(0, 0);
			}
		}
	}
	public void mouseDragged(MouseEvent e) {
		int modif = e.getModifiers();
		limitMousePos(e);
		// handle middle mouseclicks resp. Shift-clicks
		if ((modif & InputEvent.BUTTON2_MASK) > 0
			|| (((modif & InputEvent.BUTTON1_MASK) > 0)
				& ((modif & InputEvent.SHIFT_MASK) > 0))) {
			zdPane.scale(e.getY() - zoomRef);
		} else {
			zdPane.translate(0, e.getY());
		}
		mouseMoved(e);
		repaint();
	}

	public void mouseReleased(MouseEvent e) {}

}