/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.markov.runtime.ui;

import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.List;

import ch.ethz.exorciser.markov.runtime.Symbol;

public class Line {

   private List vSymbol = new ArrayList();

   public int in_begin = -1;

   public int in_end = -1;

   public int out_begin = -1;

   public int out_end = -1;

   public int nr;

   public int prodNr;

   private Line prev = null;

   //	private Renderer renderer;
   public Line (String str, int y, Line previous) {
      //		renderer = rnd;
      prev = previous;
      nr = y;
      for (int i = 0; i < str.length(); i++) {
         vSymbol.add(new Symbol(str.substring(i, i + 1), i, nr));
      }
   }

   public void setIn (int begin, int end) {
      in_begin = begin;
      in_end = end;
   }

   public void setOut (int begin, int end) {
      out_begin = begin;
      out_end = end;
   }

   public void setProdNr (int num) {
      prodNr = num;
   }

   public String toString () {
      String tmp = ""; //$NON-NLS-1$
      for (int i = 0; i < vSymbol.size(); i++) {
         tmp = tmp.concat(((Symbol) vSymbol.get(i)).toString());
      }
      return tmp;
   }

   public void paint (Renderer r, Graphics2D g) {
      r.paintLineNr(nr, g);
      for (int i = 0; i < vSymbol.size(); i++) {
         ((Symbol) vSymbol.get(i)).paint(r, g);
      }
      r.paintConnection(this, g);
   }

   public Line getPrev () {
      return this.prev;
   }

   public void setFirst () {
      for (int i = 0; i < vSymbol.size(); i++) {
         ((Symbol) vSymbol.get(i)).setFirst();
      }
      in_begin = -1;
      in_end = -1;
      out_begin = -1;
      out_end = -1;
      nr = 0;
   }
} // Line
