/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.rl.fa2re;

import ch.ethz.exorciser.fsmgui.ComponentRenderer;
import ch.ethz.exorciser.fsmgui.FSMStateInterface;
import ch.ethz.exorciser.rl.re.RegularExpression;

/**
 * @author Pascal Erni
 * @author Vincent Tscherter
 */
public class Fa2ReElement {

   public static int DELETE = 1;

   public static int CHANGE = 2;

   public static int NEW = 3;

   public static int DONE = 4;

   private Object MARK_RED = ComponentRenderer.MARK_RED;

   private Object MARK_GREEN = ComponentRenderer.MARK_GREEN;

   private Object MARK_BLUE = ComponentRenderer.MARK_BLUE;

   private Object MARK_NOT_MARKED = ComponentRenderer.MARK_NOT_MARKED;

   //	private Object MARK_MARKED = ComponentRenderer.MARK_MARKED;
   boolean isState;

   public int status;

   public FSMStateInterface from;

   public FSMStateInterface to;

   public RegularExpression solution;

   public String beginRe;

   public String wrongAnser;

   public Fa2ReElement (FSMStateInterface from, FSMStateInterface to, int status) {
      this.isState = false;
      this.from = from;
      this.to = to;
      this.status = status;
      this.wrongAnser = ""; //$NON-NLS-1$
   }

   public Fa2ReElement (FSMStateInterface s, int status) {
      this.from = s;
      this.isState = true;
      this.status = status;
   }

   public Object getMark () {
      if (status == DELETE) return MARK_BLUE;
      if (status == CHANGE) return MARK_RED;
      if (status == NEW) return MARK_RED;
      if (status == DONE) return MARK_GREEN;
      return MARK_NOT_MARKED;
   }

   public FSMStateInterface getState () {
      return from;
   }

   public FSMStateInterface getFromState () {
      return from;
   }

   public FSMStateInterface getToState () {
      return to;
   }

   public boolean isState () {
      return isState;
   }

   public boolean isTransition () {
      return (isState == false);
   }
}