/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.rl.minfa;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import ch.ethz.exorciser.Shared;

/**
 * @author Alexander Imfeld
 * @author Vincent Tscherter
 * @author Reto Lamprecht
 */
public class Popups implements ActionListener {

   protected TableView tv;

   protected JPopupMenu menu;

   protected JMenuItem undoItem;

   protected JMenuItem redoItem;

   public Popups (TableView tv) {
      this.tv = tv;
      menu = new JPopupMenu();
      undoItem = new JMenuItem(Shared.UNDO);
      undoItem.addActionListener(this);
      redoItem = new JMenuItem(Shared.REDO);
      redoItem.addActionListener(this);
      
   }

   public JPopupMenu getPopup () {
      menu.removeAll();
      menu.add(undoItem);
      if (tv.model.getOperations().undoPossible()) {
         undoItem.setEnabled(true);
      } else {
         undoItem.setEnabled(false);
      }
      menu.add(redoItem);
      if (tv.model.getOperations().redoPossible()) {
         redoItem.setEnabled(true);
      } else {
         redoItem.setEnabled(false);
      }
      return menu;
   }

   public void actionPerformed (ActionEvent e) {
      String item = e.getActionCommand();
      if (Shared.UNDO == item) { //$NON-NLS-1$
         tv.model.getOperations().undo();
      } else if (Shared.REDO == item) { //$NON-NLS-1$
         tv.model.getOperations().redo();
      }
      tv.updateBounds();
      tv.repaint();
   }
}