/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.rl.re;

import ch.ethz.exorciser.Debug;
import ch.ethz.exorciser.ifa.FA;

/**
 * @author Vincent Tscherter
 */
public abstract class RegularExpression {

   protected FA fa;

   public boolean equals (Object obj) {
      try {
         boolean res = fa.isEquivalent(((RegularExpression) obj).getFA());
         return res;
      } catch (Exception ex) {
         Debug.showException(ex);
      }
      return false;
   }

   public abstract Object clone ();

   public FA getFA () {
      return fa;
   }

   public abstract String getPrefixForm ();

   public abstract String getSuffixForm ();

   public abstract String getInfixForm ();

   public abstract String getBackusNaurForm ();

   public String toString () {
      return getInfixForm();
   }
}