/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.treebrowser;

import java.util.List;

/**
 * Abstract Tree Class used as an Interface between a Treebrowser and Tree
 * implementations. Used together with Node and Edge
 * 
 * @author Oliver Biderbost
 */
public abstract class Tree {

   protected List _nodes = null;

   protected Node _root = null;

   //	public abstract void init();
   public abstract int numNodes ();

   public abstract int numVisibleNodes ();

   public Node root () {
      return _root;
   }

   public abstract void showAll ();
   //	public abstract void showHighlights();
}