/*
 * Exorciser - Automated generation and grading of exercises in an introductory
 * course on the Theory of Computation,
 * 
 * Copyright (C) 2000-2004 Vincent Tscherter et al., Swiss Federal Institue of
 * Technology, Zrich Switzerland
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package ch.ethz.exorciser.treebrowser;

import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputAdapter;

/**
 * all the listeners for the tree
 * 
 * @author Philipp Schlegel
 */
public class TreeBrowserTreeListener extends MouseInputAdapter implements
      ComponentListener {

   int x = 0;

   int y = 0;

   /**
    * @see java.awt.event.ComponentListener#componentResized(ComponentEvent)
    */
   public void componentResized (ComponentEvent e) {
      TreeBrowserTree tbt = (TreeBrowserTree) e.getComponent();
      tbt.initTree();
   }

   /**
    * @see java.awt.event.ComponentListener#componentMoved(ComponentEvent)
    */
   public void componentMoved (ComponentEvent e) {}

   /**
    * @see java.awt.event.ComponentListener#componentShown(ComponentEvent)
    */
   public void componentShown (ComponentEvent e) {}

   /**
    * @see java.awt.event.ComponentListener#componentHidden(ComponentEvent)
    */
   public void componentHidden (ComponentEvent e) {}

   /**
    * @see java.awt.event.MouseListener#mousePressed(MouseEvent)
    */
   public void mousePressed (MouseEvent e) {
      x = e.getX();
      y = e.getY();
   }

   /**
    * @see java.awt.event.MouseListener#mouseReleased(MouseEvent)
    */
   public void mouseReleased (MouseEvent e) {
      if ((e.getX() > x - 3) && (e.getX() < x + 3) && (e.getY() > y - 3)
            && (e.getY() < y + 3)) {
         TreeBrowserTree tbt = (TreeBrowserTree) e.getComponent();
         tbt.handleMouseClicked(e.getX(), e.getY());
      }
   }
}